import { __decorate } from 'tslib';
import { ɵɵdefineInjectable, Injectable, EventEmitter, Renderer2, Input, Output, Component, Pipe, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

var DropdownService = /** @class */ (function () {
    function DropdownService() {
    }
    DropdownService.ɵprov = ɵɵdefineInjectable({ factory: function DropdownService_Factory() { return new DropdownService(); }, token: DropdownService, providedIn: "root" });
    DropdownService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], DropdownService);
    return DropdownService;
}());

var DropdownComponent = /** @class */ (function () {
    function DropdownComponent(renderer) {
        var _this = this;
        this.renderer = renderer;
        this.dropdownList = [];
        this.selectedUnit = '';
        this.selectedDropdown = new EventEmitter();
        this.sCurveDropdown = false;
        this.menuBtnClick = false;
        this.dropdownSelect = '';
        this.dropdownWidth = 100;
        this.renderer.listen('window', 'click', function (e) {
            if (!_this.menuBtnClick) {
                _this.sCurveDropdown = false;
            }
            _this.menuBtnClick = false;
        });
    }
    DropdownComponent.prototype.ngOnInit = function () {
    };
    DropdownComponent.prototype.ngOnChanges = function (changes) {
        if (this.selectedUnit && this.dropdownList.includes(this.selectedUnit)) {
            // this.dropdownSelect = this.selectedUnit;
            this.unitNameSelect(this.selectedUnit);
        }
        else {
            // this.dropdownSelect = this.dropdownList[0];
            this.unitNameSelect(this.dropdownList[0]);
        }
    };
    DropdownComponent.prototype.preventCloseOnClick = function () {
        this.menuBtnClick = true;
    };
    DropdownComponent.prototype.dropdownShow = function () {
        this.sCurveDropdown = !this.sCurveDropdown;
    };
    DropdownComponent.prototype.unitNameSelect = function (unitName) {
        this.dropdownSelect = unitName;
        if (this.dropdownSelect) {
            this.selectedDropdown.emit(this.dropdownSelect);
        }
        var number = 0;
        this.dropdownList.forEach(function (element) {
            if (number < element.length) {
                number = element.length;
            }
        });
        var width = number * 12;
        if (this.dropdownWidth < width) {
            this.dropdownWidth = width;
        }
        this.sCurveDropdown = false;
    };
    DropdownComponent.ctorParameters = function () { return [
        { type: Renderer2 }
    ]; };
    __decorate([
        Input()
    ], DropdownComponent.prototype, "dropdownList", void 0);
    __decorate([
        Input()
    ], DropdownComponent.prototype, "selectedUnit", void 0);
    __decorate([
        Output()
    ], DropdownComponent.prototype, "selectedDropdown", void 0);
    DropdownComponent = __decorate([
        Component({
            selector: 'lib-dropdown',
            template: "\n  <div class=\"dropdown\" [style.width]=\"dropdownWidth +'px'\">\n  <div\n    class=\"select-border-bottom text-dark-blue fs-14 ff-montserrat  d-flex justify-content-between align-items-center  cursor-pointer\"\n    (click)=\"dropdownShow();preventCloseOnClick()\">\n    <div class=\"fw-bold\" [title]=\"dropdownSelect\">{{dropdownSelect | dropdownFideInfo}}</div>\n    <div><i class=\"fas fa-caret-down fs-14 ms-2\"></i></div>\n  </div>\n  <div class=\"dropdown-style shadow rounded w-100 py-2\" [style.width]=\"dropdownWidth + 'px'\" *ngIf=\"sCurveDropdown\">\n    <div class=\"options text-dark-blue fs-13 ff-montserrat\" *ngFor=\"let selectItem of dropdownList\"\n      [ngClass]=\"selectItem == dropdownSelect ? 'selected-dropdown':''\"\n      (click)=\"unitNameSelect(selectItem);preventCloseOnClick()\">\n      {{selectItem}}</div>\n  </div>\n</div>\n  ",
            styles: ["\n\n.dropdown{\n  display: inline-block;\n}\n.dropdown-style{\n  position: absolute;\n  // right: 0px;\n  z-index: 10 !important;\n  background-color: white !important;\n  margin-top: 2px;\n  max-height: 250px;\n  overflow-y: auto;\n}\n.dropdown-style::-webkit-scrollbar{\n  width: 2px;\n}\n.cursor-pointer{\n  cursor: pointer;\n}\n.options{\n  padding: 0px 10px;\n  cursor: pointer;\n  white-space: nowrap;\n}\n.selected-dropdown{\n  background-color: #D2F0FF;\n}\n.options:hover{\n  background-color: #D2F0FF;\n}\n.select-border-bottom {\n  border-bottom: 1.5px solid #EEEEEE;\n}\n.text-dark-blue{\n  color: #1E3044;\n}\n.fs-13{\n  font-size: 13px;\n}\n.fs-14{\n  font-size: 14px;\n}\n// .ff-montserrat{\n  // font-family: 'am-Montserrat';\n  /* font-weight: 800; */\n// }\n.w-150px{\n  width: 150px;\n}\n.fw-bold{\n  font-weight: 800 !important;\n}\n.opacity50{\n  opacity: 0.5;\n}\n\n  "]
        })
    ], DropdownComponent);
    return DropdownComponent;
}());
var DropdownHideInfoPipe = /** @class */ (function () {
    function DropdownHideInfoPipe() {
    }
    DropdownHideInfoPipe.prototype.transform = function (value) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (value) {
            var val = value + '';
            if (val && val.length >= 15) {
                val = val.slice(0, 14) + "...";
            }
            return val;
        }
        else {
            return '';
        }
    };
    DropdownHideInfoPipe = __decorate([
        Pipe({
            name: 'dropdownFideInfo',
            pure: true,
        })
    ], DropdownHideInfoPipe);
    return DropdownHideInfoPipe;
}());

var DropdownModule = /** @class */ (function () {
    function DropdownModule() {
    }
    DropdownModule = __decorate([
        NgModule({
            declarations: [DropdownComponent, DropdownHideInfoPipe],
            imports: [
                CommonModule
            ],
            exports: [DropdownComponent]
        })
    ], DropdownModule);
    return DropdownModule;
}());

/*
 * Public API Surface of dropdown
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DropdownComponent, DropdownHideInfoPipe, DropdownModule, DropdownService };
//# sourceMappingURL=vikas-detect-dropdown.js.map
